'use strict';

function showToast(msg) {
	JsBridgeObject.showToast(msg);
}

function populateFormFields1() {

	var form = getFirstLoginForm();
	if (!form) {
		return;
	}

	var fields = form.getFields()
	var json = getJSON();

	for ( var i = 0; i < fields.length; ++i) {
		for ( var j = 0; j < json.fields.length; j++) {
			var match = fields[i].type === json.fields[j].type;
			// showToast("Match: " + match);
			// showToast("Field Type: " + fields[i].type);
			// showToast("JSON Field Type: " + json.fields[i].type);

			if (match
					|| (fields[i].type == "email" && json.fields[j].type == "text")) {
				if (json.fields[j].value) {
					fields[i].value = json.fields[j].value;
					// showToast('Setting field value: ' + json.fields[j].value
					// );
				}
			}
		}
	}
}

function getJSON() {
	var str = JsBridgeObject.getJSON();

	var json = null;
	try {
		json = JSON.parse(str);
	} catch (exception) {
		showToast('Exception: ' + exception);
	}

	return json;
}

function populateFormFields() {
	var json = getJSON();
	var formToSubmit;

	for ( var j = 0; j < json.fields.length; j++) {
		var element = document.getElementsByName(json.fields[j].name);
		if (element.length > 0) {
			formToSubmit = element[0].form;
		} else {
			formToSubmit = null;
			break;
		}
	}

	var form = null;
	if (formToSubmit) {
		for ( var j = 0; j < json.fields.length; j++) {
			var element = document.getElementsByName(json.fields[j].name);
			if (element[0].type !== "checkbox") {
				if (json.fields[j].value) {
					element[0].value = json.fields[j].value;
					element[0].lunabeeValue = json.fields[j].value;
				}
			}
		}

		// Removing label texts used as placeholders.
//		removeLabelText("placeholder", formToSubmit.childNodes);

		form = detectFormFieldsAndButtons(formToSubmit);
	} else {
		form = getFirstLoginForm();
		if (!form) {
			return;
		}
		var fields = form.getFields()
		for ( var i = 0; i < fields.length; ++i) {
			for ( var j = 0; j < json.fields.length; j++) {
				if (fields[i].type === json.fields[j].type
						|| (fields[i].type == "email" && json.fields[j].type == "text")) {
					if (json.fields[j].value) {
						fields[i].value = json.fields[j].value;
						fields[i].lunabeeValue = json.fields[j].value;
					}
				}
			}
		}

		// Removing label texts used as placeholders.
//		removeLabelText("placeholder", form.getForm().childNodes);
	}
	if (form && json.autoSubmit === "1") {

		setTimeout(function() {
			var fields = form.getFields();
			var jsonFields = [];
			for ( var j = 0; j < fields.length; j++) {
				if (fields[j].type === "checkbox") {
					jsonFields.push({
						value : "" + fields[j].checked,
						name : fields[j].name,
						type : fields[j].type,
					});
				} else {
					jsonFields.push({
						value : fields[j].value,
						name : fields[j].name,
						type : fields[j].type,
					});
				}
			}
			var json = {
				"action" : "SUBMIT",
				"URL" : document.URL,
				"fields" : jsonFields,
				// "title" : document.title,
				"favicon" : "http://getfavicon.appspot.com/" + document.URL
			};
			JsBridgeObject.onSubmit(JSON.stringify(json));
			form.getForm().submit();
		}, 500);
	}
}

function Form(myForm, myFiels, myButtons) {
	// Attributes
	var domForm;
	var fields;
	var buttons;

	this.getForm = function() {
		return domForm;
	}

	// Methods
	this.getFields = function() {
		return fields;
	}

	this.getButtons = function() {
		return buttons;
	}

	// Constructor
	this.constructor = function(myForm, myFields, myButtons) {
		domForm = myForm;
		fields = myFields;
		buttons = myButtons;
	}

	this.constructor(myForm, myFiels, myButtons);
}

var getFirstLoginForm = function() {
	var nbPasswordFields;
	var currentFormFields;
	var allForms = document.forms;

	for ( var i = 0; i < allForms.length; i++) {
		nbPasswordFields = 0;
		currentFormFields = allForms[i].getElementsByTagName("input");

		for ( var j = 0; j < currentFormFields.length; j++) {
			if (currentFormFields[j].type === "password") {
				nbPasswordFields++;
			}
		}

		if (nbPasswordFields == 1) {
			return detectFormFieldsAndButtons(allForms[i]);
		}
	}

	return null;
}

var detectFormFieldsAndButtons = function(form) {
	var detectedFields = new Array();
	var detectedButtons = new Array();
	var inputElements = form.getElementsByTagName("input");
	var selectElements = form.getElementsByTagName("select");
	var buttonElements = form.getElementsByTagName("button");

	for ( var i = 0; i < inputElements.length; i++) {
		if (inputElements[i].type === "submit"
				|| inputElements[i].type === "button") {
			detectedButtons.push(inputElements[i]);
		} else if (inputElements[i].type !== "hidden") {
			detectedFields.push(inputElements[i]);
		}
	}

	for ( var i = 0; i < selectElements.length; i++) {
		detectedFields.push(selectElements[i]);
	}

	for ( var i = 0; i < buttonElements.length; i++) {
		if (buttonElements[i].type === "submit") {
			detectedButtons.push(buttonElements[i]);
		}
	}

	return new Form(form, detectedFields, detectedButtons);
}

var removeLabelText = function(labelClass, elements) {
	for ( var i = 0; i < elements.length; i++) {
		if ((elements[i].tagName === "LABEL")
				&& (elements[i].className.indexOf(labelClass) != -1)) {
			jQuery(elements[i]).html("");
		} else if ((elements[i].tagName === "SPAN")
				|| (elements[i].tagName === "DIV")) {
			removeLabelText(labelClass, elements[i].childNodes);
		}
	}
}
